#include <simpletools.h>
#include <fdserial.h>
#include <servo.h>
#include "ws2812.h"

void getPix(void);

#define CENTER 1500
#define LED_PIN     0
#define LED_COUNT   64
#define PAN 8
#define TILT 9
#define PSRV 16
#define SCALE 10
uint32_t ledColors[LED_COUNT];
ws2812_t driver;
fdserial *ser;
int n;

int main() {
   set_directions(27, 26, 0b11);
   ser = fdserial_open(6, 7, 0, 115200);   
   
   if (ws2812b_init(&driver) < 0) {
     return 1;
   }       
   ws2812_refresh(&driver, LED_PIN, ledColors, LED_COUNT); 
   servo_set(PAN, CENTER);
   servo_set(TILT, CENTER);
   servo_set(PSRV, CENTER); 
     
   for (;;) {
     toggle(26);
     n = 0;
     while(n < 64) {
       ledColors[n++] = 0;
     }
     getPix();
     ws2812_refresh(&driver, LED_PIN, ledColors, LED_COUNT);
     pause(10);   
   }
   return 0;
}

void getPix(void) {
   n = 0;
   while(1) {
     if(fdserial_rxCheck(ser) == 33) {
       if(fdserial_rxTime(ser, 1) == 38) {
         toggle(27);
         while(n < 64) {
           ledColors[n] |= fdserial_rxChar(ser) / SCALE;
           ledColors[n] |= fdserial_rxChar(ser) / SCALE << 8 ;
           ledColors[n++] |= fdserial_rxChar(ser) / SCALE << 16;
         }
         break;   
       }          
     }       
  } 
}  