#include <opencv2/highgui/highgui.hpp>
#include <opencv2/core/core.hpp>
#include <opencv2/imgproc/imgproc.hpp>
#include <iostream>
#include <wiringSerial.h>

using namespace cv;
using namespace std;

int main() {
    Mat frame;
    VideoCapture cap(0);
    int fd(serialOpen("/dev/ttyAMA0", 115200));
    for(;;) {
     cap >> frame;
     resize(frame, frame, Size(80, 80));
     imshow("", frame);
     serialPuts(fd, "!&");
     for(int y(33); y < 41; y++) {
       for(int x(33); x < 41; x++) {
         Vec3b intensity = frame.at<Vec3b>(y, x);
         serialPutchar(fd, intensity.val[0]);
         serialPutchar(fd, intensity.val[1]);
         serialPutchar(fd, intensity.val[2]);
       }
     }
     if (waitKey(1) == 27) { /* 'esc' key press exits program */
      cap.release();
      serialClose(fd);
      destroyAllWindows();
      break;
     }
    }
    return 0;
}
